- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# AbstractEuclideanDomain< T > Class Template Reference

`#include <algebra.h>`

Inheritance diagram for AbstractEuclideanDomain< T >:

List of all members.

## Detailed Description

### template<class T>
class AbstractEuclideanDomain< T >

Abstract Euclidean Domain.

Definition at line 138 of file algebra.h.

## Public Types
typedef T | Element
## Public Member Functions
virtual void | DivisionAlgorithm (Element &r, Element &q, const Element &a, const Element &d) const=0
virtual const Element & | Mod (const Element &a, const Element &b) const=0
virtual const Element & | Gcd (const Element &a, const Element &b) const
virtual bool | IsUnit (const Element &a) const =0
virtual const Element & | MultiplicativeIdentity () const=0
virtual const Element & | Multiply (const Element &a, const Element &b) const=0
virtual const Element & | MultiplicativeInverse (const Element &a) const =0
virtual const Element & | Square (const Element &a) const
virtual const Element & | Divide (const Element &a, const Element &b) const
virtual Element | Exponentiate (const Element &a, const Integer &e) const
virtual Element | CascadeExponentiate (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
virtual const AbstractGroup< T > & | MultiplicativeGroup () const
virtual bool | Equal (const Element &a, const Element &b) const=0
virtual const Element & | Identity () const=0
virtual const Element & | Add (const Element &a, const Element &b) const=0
virtual const Element & | Inverse (const Element &a) const =0
virtual bool | InversionIsFast () const
virtual const Element & | Double (const Element &a) const
virtual const Element & | Subtract (const Element &a, const Element &b) const
virtual Element & | Accumulate (Element &a, const Element &b) const
virtual Element & | Reduce (Element &a, const Element &b) const
virtual Element | ScalarMultiply (const Element &a, const Integer &e) const
virtual Element | CascadeScalarMultiply (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
virtual void | SimultaneousMultiply (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
## Protected Attributes
Element | result

The documentation for this class was generated from the following files:

- algebra.h
- algebra.cpp